Module mndr
  implicit none
  
  ! ---- (for getting cpu time & elasped time) ----
  integer                                :: t_elsp1, t_elsp2, t_rate, t_max, diff

  ! ---- set_parameter ----
  real*8                                 :: pi, g, s, dm, u0, h0, dt
  integer                                :: intbl, intbl2, intbl3

  ! ---- read_fln ----
  integer                                :: n, nend
  character*100,dimension(:),allocatable :: fln
  character*4,dimension(:),allocatable   :: fln2
  character*4,dimension(:),allocatable   :: time1
  real*8,dimension(:),allocatable        :: time2

  ! ---- read_array ----
  integer                                :: i, iend, j, jend
 
  ! ---- set_pss ----
  character*100                          :: pss_st, pss_iric

  ! ---- read_roughness ----
  real*8,dimension(:,:),allocatable      :: nb

  ! ---- cal_critical_shear_stress ----
  real*8                                 :: tauc
 
  ! ---- filter ----  
  real*8                                 :: count
  
  ! ==== set_array at bellow ========  ! You could have to refer to delete if you don't wanna use them
  ! ---- read vtk for dz/dt & du/dt (obs) ----
  real*8,dimension(:,:,:),allocatable    :: bl2, u_cal2, dep_cal2, dep_obs2, fr2
  
  ! ---- read vtk for ST ----
  real*8,dimension(:,:),allocatable      :: x, y
  real*8,dimension(:,:),allocatable      :: dwl_obs, wl_obs, dev_bl, bl, dep_obs

  ! ---- read vtk for iRIC ----
  real*8,dimension(:,:),allocatable      :: dep_cal, wl_cal, u_cal, v_cal
  real*8,dimension(:,:),allocatable      :: Fr, vel_cal, flux
  
  ! ---- cal_slope & curvature & velocity ----
  real*8,dimension(:,:),allocatable      :: iwj_obs   , iwi_obs   , iw_obs
  real*8,dimension(:,:),allocatable      :: iwj_cal   , iwi_cal   , iw_cal
  real*8,dimension(:,:),allocatable      :: dudx_cal  , dudy_cal  , dudr_cal
  real*8,dimension(:,:),allocatable      :: dvdx_cal  , dvdy_cal  , dvdr_cal
  real*8,dimension(:,:),allocatable      :: dhdx_cal  , dhdy_cal  , dhdr_cal
  real*8,dimension(:,:),allocatable      :: dhdx_obs  , dhdy_obs  , dhdr_obs
  real*8,dimension(:,:),allocatable      :: ibi       , ibj       , ib  
  real*8,dimension(:,:),allocatable      :: cbj       , cbi       , cb
  real*8,dimension(:,:),allocatable      :: iej       , iei       , ie
  real*8,dimension(:,:),allocatable      :: diexdx_cal, diexdy_cal, diexdr_cal
  real*8,dimension(:,:),allocatable      :: dieydx_cal, dieydy_cal, dieydr_cal
  real*8,dimension(:,:),allocatable      :: diedx_cal , diedy_cal , diedr_cal
  real*8,dimension(:,:),allocatable      :: dveldx_cal, dveldy_cal, dveldr_cal

  ! ---- calculate shields_number  &  M equation ----
  real*8,dimension(:,:),allocatable      :: taue_i    , taue_j    , taue , tautau
  real*8,dimension(:,:),allocatable      :: Mx        , My        , Mxy
  real*8,dimension(:,:),allocatable      :: dhdx_M    , dhdy_M
  real*8,dimension(:,:),allocatable      :: fx        , fy
  real*8,dimension(:,:),allocatable      :: fx2       , fy2
  real*8,dimension(:,:),allocatable      :: Df        , Pe
  real*8,dimension(:,:),allocatable      :: dz_cal

  real*8,dimension(:,:),allocatable      :: Mx_old    , My_old    , Mxy_old
  real*8,dimension(:,:),allocatable      :: dhdx_old , dhdy_old
  real*8,dimension(:,:),allocatable      :: fx_old    , fy_old
  real*8,dimension(:,:),allocatable      :: dz_old

  real*8,dimension(:,:),allocatable      :: Mx_str, My_str, Mxy_str
  real*8,dimension(:,:),allocatable      :: Mx_old_str, My_old_str, Mxy_old_str

  
  ! ---- calculate_ave_std_cv_all ----
  real*8,dimension(:),  allocatable      :: ave_taue  , std_taue  , cv_taue 
  real*8,dimension(:),  allocatable      :: ave_Mx    , std_Mx    , cv_Mx
  real*8,dimension(:),  allocatable      :: ave_My    , std_My    , cv_My
  real*8,dimension(:),  allocatable      :: ave_Mxy   , std_Mxy   , cv_Mxy
  real*8,dimension(:),  allocatable      :: ave_dep_cal, std_dep_cal, cv_dep_cal
    
  ! ---- cal perstent difference between 2 physical quantity ----
  character*100                          :: diano
  
  ! ---- calculate temporal slope ----
  real*8,dimension(:,:),allocatable      :: dz_obs  

  real*8,dimension(:,:,:),allocatable    :: lcl, adv, frc, prs
  real*8,dimension(:,:,:),allocatable    :: M_2ds_str
  
  
  ! ---- calculate perstent difference between 2 physical quantity ----
  real*8,dimension(:,:),allocatable      :: dif_dep  , dif_dz
  real*8,dimension(:,:),allocatable      :: dif_dhdx , dif_dhdy
  real*8,dimension(:,:),allocatable      :: dif_dz_old
  
  ! ---- calculate time waveform ----
  real*8,dimension(:,:,:),allocatable    :: dev_bl_cal
  real*8,dimension(:,:,:),allocatable    :: dev_bl_old
  
  ! ---- output vtk ----  
  integer                                :: ic, jc, ijc, intrvl_i, intrvl_j
  
  ! ---- drw_cntr ----
  integer                                :: plparseopts_rc
  integer                                :: clrnm
  character*100                          :: chr     , case  , stage , nchr  , hst_per
  character*100                          :: barsname, axis_b, axis_l, axis_t, axis_r
  real*8                                 :: pxmin   , pxmax , pymin , pymax , pdy   , pzmin, pzmax
  real*8                                 :: xmin    , xmax  , ymin  , ymax  , zmin  , zmax
  real*8                                 :: con     , con1  , wdth
  integer                                :: p, pend
  real*8,dimension(:),allocatable        :: hst_x   , hst_y
  real*8                                 :: blim

end Module mndr
